//**Written by Amy Zhang at Jan.2019 in Wuhan University
//baseline model 
//no financial sector, introducing consumption habit in household sectors
var c1 lambda1 i pi r qh h1 n1 nc1 nh1 wc wh; %patient household 12 qh is house' price
var c2 lambda2 lambda3 h2 b2 n2 nc2 nh2;%impatient household 9
var ch kh nh inv_h Q_h yh bh lambdahe lambdahc; %real estate sector 11,ldh is land's price,Q_h new capital's price
var cc kc nc inv_c Q_c yc bc lambdace lambdacc xc; %consumption sector 11,ldc land's price, xc markup
var y c inv;
var j;
var u_i u_c u_a u_invh u_invc;
varexo  e_i e_c e_a e_invh e_invc e_j;
parameters beta1  LAMBDA1 lab_phi tao xi_nc xi_nh Rss; %patient
parameters LAMBDA2 Jss c2_yc m2 beta2; %impatient

parameters alpha_c the_h  alpha_h  delta_k delta_h betae xh_ky xh_by xh_iy xh_cy kappa_hk ;%real estate
parameters alpha the_c betac xc_ky xc_by xc_iy xc_cy XCss kappa_ck thet;%consumption 
parameters gamma rto_h1 c1_yc;
parameters rho phi_pi phi_y rho_c rho_i rho_a rho_invh rho_invc;
parameters rho_j;
parameters habit;
habit=0.815;
m2=0.55;
the_h= 0.75;
the_c=0.3;
tao       = 1; //
beta1     = 0.988; //
beta2     = 0.95; //
lab_phi = 0.5; % 
Rss = 1/beta1;

delta_h   = 0.008;
delta_k   = 0.025;

LAMBDA1=1/(1-beta1*(1-delta_h));
LAMBDA2=1/(1-beta2*(1-delta_h)-(1-beta2*Rss)*m2*(1-delta_h)/Rss);
alpha=0.7; %patient household ratio

gamma=0.9;%
Jss         = 0.1103;//
kappa_ck   = 3.5; // capital ajustment cost
kappa_hk   = 3.5; // capital ajustment cost

betae= 0.96;
alpha_h = 0.4; % 
xh_ky=betae*alpha_h/(1-betae*(1-delta_k)-the_h*(1/Rss-betae));
xh_by=xh_ky/Rss;
xh_iy=delta_k*xh_ky;
xh_cy=xh_ky*(1/Rss-1-delta_k)+alpha_h;


XCss = 1.05;
betac= 0.97;
alpha_c = 0.5 ; % 
xc_ky=(betac*alpha_c/XCss)/(1-betac*(1-delta_k)-the_c*(1/Rss-betac));
xc_by=xc_ky/Rss;
xc_iy=delta_k*xc_ky;
xc_cy=xc_ky*(1/Rss-1-delta_k)+alpha_c/XCss;

c2_yc=((1-alpha_c)*(1-alpha)/XCss+(1-alpha_h)*(1-alpha)*(1-gamma)/gamma)/(1+delta_h*Jss*LAMBDA2*(1-habit)/(1-beta2*habit)+(1-1/Rss)*m2*(1-delta_h)*LAMBDA2*Jss*(1-habit)/(1-beta2*habit));
c1_yc =1-c2_yc - xh_cy*(1-gamma)/gamma - xc_cy - xc_iy - xh_iy*(1-gamma)/gamma;

xi_nc = ((1-alpha_c)*(1-alpha)/XCss)/((1-alpha_c)*(1-alpha)/XCss+(1-alpha_h)*(1-alpha)*(1-gamma)/gamma) ; %
xi_nh  = 1 - xi_nc;
rto_h1=LAMBDA1*c1_yc*(1-habit)/(1-beta1*habit)/(LAMBDA1*c1_yc*(1-habit)/(1-beta1*habit)+LAMBDA2*c2_yc*(1-habit)/(1-beta2*habit));
thet=0.8;

rho=0.8;
phi_pi=1.5;
phi_y=0.125;
rho_c=0.8;
rho_i=0.8;
rho_a=0.8;
rho_invh=0.8;
rho_invc=0.8;

rho_j=0.8;

model(linear);
//************************************Patient Household*******************************//7
lambda1=-(c1-habit*c1(-1)-beta1*habit*(c1(+1)-habit*c1))/((1-beta1*habit)*(1-habit))+u_c;
lambda1 = lambda1(+1)+i-pi(+1);
j- h1 = (lambda1 + qh)*LAMBDA1 - beta1*(1-delta_h)*(lambda1(+1)+qh(+1))*LAMBDA1;
lambda1+wc = (lab_phi-1/tao)*n1+1/tao*nc1;
lambda1+wh = (lab_phi-1/tao)*n1+1/tao*nh1;
n1 = xi_nc*nc1 + xi_nh*nh1;
i=r+pi(+1);

//************************************Impatient Household*******************************//8
lambda2=-(c2-habit*c2(-1)-beta2*habit*(c2(+1)-habit*c2))/((1-beta2*habit)*(1-habit))+u_c;
lambda2 = (1-beta2*Rss)*lambda3+beta2*Rss*(lambda2(+1)+i-pi(+1));
j-h2 =LAMBDA2*(lambda2+qh) - beta2*(1-delta_h)*LAMBDA2*(lambda2(+1)+qh(+1)) - m2*(1-delta_h)*((1-beta2*Rss)/Rss)*LAMBDA2*(lambda3+qh(+1)+pi(+1)-i);
lambda2+wc=(lab_phi-1/tao)*n2+nc2/tao;
lambda2+wh=(lab_phi-1/tao)*n2+nh2/tao;
n2 = xi_nc*nc2 + xi_nh*nh2;
b2 = qh(+1)+h2+pi(+1)-i; %
(1-alpha_c)*(1-alpha)*(nc2+wc)/XCss+(1-alpha_h)*(1-alpha)*(1-gamma)/gamma*(nh2+wh)+m2*(1-delta_h)*LAMBDA2*Jss/Rss*c2_yc*b2*(1-habit)/(1-beta2*habit)+(1-delta_h)*Jss*LAMBDA2*c2_yc*(qh+h2(-1))*(1-habit)/(1-beta2*habit)
                    = c2_yc*c2+m2*(1-delta_h)*LAMBDA2*Jss*c2_yc*(i(-1)+b2(-1)-pi)*(1-habit)/(1-beta2*habit)+Jss*c2_yc*LAMBDA2*(qh+h2)*(1-habit)/(1-beta2*habit);

//************************************Real Estate Sector*******************************//10
yh=u_a+(1-alpha_h)*nh+alpha_h*kh(-1);
(1-alpha_h)*(wh+nh)+xh_cy*ch+Rss*xh_by*(i(-1)+bh(-1)-pi)+xh_iy*inv_h=yh+qh+xh_by*bh;
bh=kh+Q_h(+1)+pi(+1)-i;
kh=(1-delta_k)*kh(-1)+delta_k*(inv_h+ u_invh); 
-ch=lambdahe+u_c;
wh=yh+qh-nh;
lambdahe=(1-betae*Rss)*lambdahc+betae*Rss*(lambdahe(+1)+i-pi(+1));
nh=alpha*nh1+(1-alpha)*nh2;
lambdahe+Q_h=(1-betae*Rss)*the_h/Rss*(lambdahc+Q_h(+1)+pi(+1)-i)+betae*alpha_h/xh_ky*(lambdahe(+1)+yh(+1)-kh+qh(+1))+betae*(1-delta_k)*(lambdahe(+1)+Q_h(+1));
inv_h=1/(1+betae)*(Q_h/kappa_hk+inv_h(-1)+betae*inv_h(+1));

//************************************Consumption Sector*******************************//11
yc=u_a+(1-alpha_c)*nc+alpha_c*kc(-1);
(1-alpha_c)*(wc+nc)/XCss+xc_cy*cc+Rss*xc_by*(i(-1)+bc(-1)-pi)+xc_iy*inv_c=(yc-xc)/XCss+xc_by*bc;
bc=kc+Q_c(+1)+pi(+1)-i;
kc=(1-delta_k)*kc(-1)+delta_k*(inv_c+u_invc);
-cc=lambdace+u_c;
wc=yc-nc-xc;
lambdace=(1-Rss*betac)*lambdacc+betac*Rss*(lambdace(+1)+i-pi(+1));
nc=alpha*nc1+(1-alpha)*nc2; 
lambdace+Q_c=(1-Rss*betac)*the_c/Rss*(lambdacc+Q_c(+1)+pi(+1)-i)+betac*alpha_c*(lambdace(+1)+yc(+1)-kc-xc(+1))/(xc_ky*XCss)+betac*(1-delta_k)*(lambdace(+1)+Q_c(+1));
inv_c=1/(1+betac)*(Q_c/kappa_ck+inv_c(-1)+betac*inv_c(+1));
pi=betac*pi(+1) - (1-betac*thet)*(1-thet)*xc/thet;

//****************Monetary policy**************//
i=rho*i(-1)+(1-rho)*(phi_pi*pi+phi_y*y)+u_i;%32

//*************market clearing*************//
y=gamma*yc+(1-gamma)*(qh+yh);
inv=xc_iy*inv_c/(xc_iy+xh_iy*(1-gamma)/gamma)+(xh_iy*(1-gamma)/gamma)*inv_h/(xc_iy+xh_iy*(1-gamma)/gamma);
c=(c1_yc*c1+c2_yc*c2+(xh_cy*(1-gamma)/gamma)*ch+xc_cy*cc)/(c1_yc+c2_yc+xh_cy*(1-gamma)/gamma+xc_cy);
yc=c1_yc*c1+c2_yc*c2+(xh_cy*(1-gamma)/gamma)*ch+xc_cy*cc+xc_iy*inv_c+(xh_iy*(1-gamma)/gamma)*inv_h;
yh=(rto_h1*(h1-(1-delta_h)*h1(-1))+(1-rto_h1)*(h2-(1-delta_h)*h2(-1)))/delta_h;

//shock dynamics
u_c=rho_c*u_c(-1)+e_c;
u_i=rho_i*u_i(-1)+e_i;
u_a = rho_a*u_a(-1)+e_a;
u_invh=rho_invh*u_invh(-1)+e_invh;
u_invc=rho_invc*u_invc(-1)+e_invc;
j=rho_j*j(-1)+e_j;
end;

model_diagnostics;
model_info;
resid(1);
steady;
check;

shocks;
//var e_c; stderr 0.1;
var e_i; stderr 0.1;
//var e_a; stderr 0.1;
//var e_s;stderr 0.1;
var e_j;stderr 0.1;
end;
stoch_simul(irf=10) y yh yc pi c1 c2 ch cc c n1 n2 nc1 nc2 nc nh1 nh2 nh inv_c qh wc wh h1 h2 lambda1 b2 bh;
//It's strange that output (total output y, output in real estate sector yh, in consumption sector yc),
//labor( n1 n2 )and other real variables respond so unsmoothly, 
//but bonds(b2 bh bc) respond so smoothly. Is there anything wrong with my model?